<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 3.4: Switch</title>
<link href="sx6c.html" rev=precedes>
<link href="sx6e.html" rel=precedes>
<link href="sx6.html" rev=subdocument>
</head>
<body>
<H2>section 3.4: Switch</H2>

pages 58-59
<p>We won't be concentrating on <TT>switch</TT> statements much
(they're a bit of a luxury;
there's nothing you can do with a <TT>switch</TT>
that you can't do with an <TT>if</TT>/<TT>else</TT> chain,
as in section 3.3 on page 57).
But they're quite handy,
and good to know about.
</p><p>The example on page 59 is about as contrived as the example in 
section 1.6
(page 22)
which it replaces,
but studying both examples will give you an excellent feel for 
how a <TT>switch</TT> statement works,
what the <TT>if</TT>/<TT>then</TT> statements are
that a <TT>switch</TT> is equivalent to
and how to map between the two,
and why a switch statement can be convenient.
</p><p>In the example
in the text,
note especially the way that ten <TT>case</TT> labels are 
attached to one set of statements
(<TT>ndigit[c-'0']++;</TT>).
As the authors point out,
this works because of the way switch cases ``fall through,''
which is a mixed blessing.
</p><p>The danger of fall-through is illustrated by:
<pre>	switch(food) {
		case APPLE:
			printf("apple\n");
<br>
<br>
		case ORANGE:
			printf("orange\n");
			break;
<br>
<br>
		default:
			printf("other\n");
	}
</pre>When <TT>food</TT> is <TT>APPLE</TT>,
this code erroneously prints
<pre>	apple
	orange
</pre>because the <TT>break</TT> statement after the <TT>APPLE</TT> case was omitted.
</p><hr>
<p>
Read sequentially:
<a href="sx6c.html" rev=precedes>prev</a>
<a href="sx6e.html" rel=precedes>next</a>
<a href="sx6.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
